//
//  GameScene.m
//  iOSX
//
//  Created by Matthew Cook on 24/1/15.
//  Copyright (c) 2015 Matthew Cook. All rights reserved.
//

#import "GameScene.h"
#import "HomeScreen.h"

static NSString * const kAnimalNodeName = @"movable";

@implementation GameScene

-(void)didMoveToView:(SKView *)view {
    /* Setup your scene here */
    SKSpriteNode *bg = [SKSpriteNode spriteNodeWithImageNamed:@"bg"];
    bg.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    bg.name = @"bg";
    [self addChild:bg];
    
    [self showGreeting];
    //[self changeScene];
}

-(void)showOSX{
    
    SKSpriteNode* osxSprite = [SKSpriteNode spriteNodeWithImageNamed:@"osxcircle"];
    osxSprite.position = CGPointMake(CGRectGetMidX(self.frame),CGRectGetMidY(self.frame));
    [osxSprite setName:@"osxcircle"];
    
    osxSprite.alpha = 0;
    [self addChild:osxSprite];
    
//    SKAction *sequence = [SKAction sequence:@[[SKAction rotateByAngle:degToRad(-20.0f) duration:0.1],
//                                              [SKAction rotateByAngle:0.0 duration:0.1],
//                                              [SKAction rotateByAngle:degToRad(20.0f) duration:0.1]]];
    SKAction* sequence = [SKAction rotateByAngle:[self degToRad:360.0f] duration:1.5];
    [osxSprite runAction:[SKAction repeatActionForever:sequence]];
    
    UILabel* iosx = [[UILabel alloc] init];
    iosx.textColor = [UIColor whiteColor];
    [iosx setFont:[UIFont fontWithName:@"HelveticaNeue-UltraLight" size:40.0f]];
    iosx.text = @"X";
    [iosx sizeToFit];
    iosx.center = CGPointMake(self.scene.view.center.x,self.scene.view.center.y);
    //iosx.center = CGPointMake(CGRectGetMidX(self.frame),CGRectGetMidY(self.frame));
    iosx.alpha = 0;
    [self.scene.view addSubview:iosx];
    
    SKAction* fadeInOSXSprite = [SKAction fadeAlphaTo:1.0 duration:0.8];
    [osxSprite runAction:fadeInOSXSprite];
    
    [UIView animateWithDuration:0.8
                          delay:0
                        options: UIViewAnimationCurveEaseOut
                     animations:^{
                         iosx.alpha = 1;
                     }
                     completion:^(BOOL finished){
                         //NSLog(@"Done!");
                     }];

}

-(void)showWelcome{
    CGFloat greetingToPos = self.scene.view.center.y + 120;
    CGFloat nameToPos = self.scene.view.center.y + 160;
    
    UILabel* welcome = [[UILabel alloc] init];
    [welcome setFont:[UIFont fontWithName:@"HelveticaNeue-UltraLight" size:26.0f]];
    welcome.textColor = [UIColor whiteColor];
    welcome.text = @"Welcome to";
    [welcome sizeToFit];
    welcome.center = CGPointMake(self.scene.view.center.x, greetingToPos);
    welcome.alpha = 0;
    
    UILabel* iosX = [[UILabel alloc] init];
    [iosX setFont:[UIFont fontWithName:@"HelveticaNeue-UltraLight" size:40.0f]];
    iosX.textColor = [UIColor whiteColor];
    iosX.text = @"iOS X";
    [iosX sizeToFit];
    iosX.center = CGPointMake(self.scene.view.center.x,  nameToPos);
    iosX.alpha = 0;
    
    [self.scene.view addSubview:welcome];
    [self.scene.view addSubview:iosX];
    
    [UIView animateWithDuration:0.8
                          delay:1.0
                        options: UIViewAnimationCurveEaseOut
                     animations:^{
                         welcome.center = CGPointMake(self.scene.view.center.x, greetingToPos);
                         iosX.center = CGPointMake(self.scene.view.center.x, nameToPos);
                         welcome.alpha = 1.0;
                         iosX.alpha = 1.0;
                     }
                     completion:^(BOOL finished){
                     }];
    
}

-(void)showGreeting{
    CGFloat greetingToPos = self.scene.view.center.y - 180;
    CGFloat nameToPos = self.scene.view.center.y - 140;
    
    UILabel* greeting = [[UILabel alloc] init];
    [greeting setFont:[UIFont fontWithName:@"HelveticaNeue-Light" size:22.0f]];
    greeting.textColor = [UIColor whiteColor];
    greeting.text = @"Good Morning!";
    [greeting sizeToFit];
    greeting.center = CGPointMake(self.scene.view.center.x, greetingToPos - 40);
    greeting.alpha = 0;
    
    UILabel* name = [[UILabel alloc] init];
    [name setFont:[UIFont fontWithName:@"HelveticaNeue-UltraLight" size:40.0f]];
    name.textColor = [UIColor whiteColor];
    name.text = @"Matthew";
    [name sizeToFit];
    name.center = CGPointMake(self.scene.view.center.x,  nameToPos - 40);
    name.alpha = 0;
    
    [self.scene.view addSubview:greeting];
    [self.scene.view addSubview:name];
    
    [UIView animateWithDuration:0.8
                          delay:1.0
                        options: UIViewAnimationCurveEaseOut
                     animations:^{
                         greeting.center = CGPointMake(self.scene.view.center.x, greetingToPos);
                         name.center = CGPointMake(self.scene.view.center.x, nameToPos);
                         greeting.alpha = 1.0;
                         name.alpha = 1.0;
                     }
                     completion:^(BOOL finished){
                         [self showOSX];
                         [self showWelcome];
                         [self runAction:[SKAction playSoundFileNamed:@"welcome.m4a" waitForCompletion:YES] completion:^{
                             [self changeScene];
                         }];
                         //NSLog(@"Done!");
                     }];

}



- (void)selectNodeForTouch:(CGPoint)touchLocation {
    //1
    SKSpriteNode *touchedNode = (SKSpriteNode *)[self nodeAtPoint:touchLocation];
    
    //2
    if(![_selectedNode isEqual:touchedNode]) {
        [_selectedNode removeAllActions];
        [_selectedNode runAction:[SKAction rotateToAngle:0.0f duration:0.1]];
        
        _selectedNode = touchedNode;
        //3
        
        if([[touchedNode name] isEqualToString:@"phone"]) {
            SKAction *sequence = [SKAction sequence:@[[SKAction rotateByAngle:[self degToRad:-20.0f] duration:0.1],
                                                      [SKAction rotateByAngle:0.0 duration:0.1],
                                                      [SKAction rotateByAngle:[self degToRad:20.0f] duration:0.1]]];
            [_selectedNode runAction:[SKAction repeatActionForever:sequence]];
        }
    }
    
}

- (void)willMoveFromView:(SKView *)view
{
    [super willMoveFromView:view];
    
}

- (void)changeScene{
    
    NSLog(@"%@",NSStringFromCGSize(self.size));
    
    [UIView animateWithDuration:0.7
                          delay:0.0
                        options: UIViewAnimationCurveEaseOut
                     animations:^{
                         for(int i = 0; i < [[self.scene.view subviews] count]; i++){
                             UIView* aView = [[self.scene.view subviews] objectAtIndex:i];
                             aView.alpha = 0;
                         }
                     }
                     completion:^(BOOL finished){
                         [[self.scene.view subviews] makeObjectsPerformSelector:@selector(removeFromSuperview)];
                         SKScene *homeScene = [[HomeScreen alloc] initWithSize:self.size];
                         //homeScene.scaleMode = SKSceneScaleModeAspectFill;
                         SKTransition *transition = [SKTransition crossFadeWithDuration:0.7];
                         [self.view presentScene:homeScene transition:transition];
                         //[[self.scene.view subviews] makeObjectsPerformSelector:@selector(removeFromSuperview)];
                     }];
}


//-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
//    /* Called when a touch begins */
//    
//    for (UITouch *touch in touches) {
//        CGPoint location = [touch locationInNode:_sprite];
//        
//        SKSpriteNode *sprite = [SKSpriteNode spriteNodeWithImageNamed:@"Spaceship"];
//        
//        sprite.xScale = 0.5;
//        sprite.yScale = 0.5;
//        sprite.position = location;
//        
//        SKAction *action = [SKAction rotateByAngle:M_PI duration:1];
//        
//        [sprite runAction:[SKAction repeatActionForever:action]];
//        
//        [self addChild:sprite];
//    }
//}

-(void)update:(CFTimeInterval)currentTime {
    /* Called before each frame is rendered */
}

-(float) degToRad:(float) degree {
    return degree / 180.0f * M_PI;
}

@end
