//
//  HomeScreen.m
//  iOSX
//
//  Created by Matthew Cook on 25/1/15.
//  Copyright (c) 2015 Matthew Cook. All rights reserved.
//

#import "HomeScreen.h"
#import "GameScene.h"

@implementation HomeScreen


-(void)didMoveToView:(SKView *)view {
    SKSpriteNode *bg = [SKSpriteNode spriteNodeWithImageNamed:@"bg"];
    bg.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    bg.name = @"bg";
    [self addChild:bg];
    
    [self showHomeScreen];
}

-(void)showHomeScreen{
    CGFloat firstRowHeight = 1136 - 250;
    CGFloat secondRowHeight = firstRowHeight  - 250;
    CGFloat thirdRowHeight = secondRowHeight - 250;
    CGFloat firstCol = 120;
    CGFloat secondCol = CGRectGetMidX(self.frame);
    CGFloat thirdCol = self.frame.size.width - 120;
    
    
    
    SKSpriteNode *phone = [SKSpriteNode spriteNodeWithImageNamed:@"Phone"];
    //phone.position = CGPointMake(firstCol, firstRowHeight);
    NSLog(@"%f", CGRectGetMidX(self.frame)-self.view.frame.size.width/2 + 20);
    phone.name = @"phone";
    [self addChild:phone];
    
    SKSpriteNode *iMessage = [SKSpriteNode spriteNodeWithImageNamed:@"iMessage"];
    //iMessage.position = CGPointMake(secondCol, firstRowHeight);
    iMessage.name = @"iMessage";
    [self addChild:iMessage];
    
    SKSpriteNode *photo = [SKSpriteNode spriteNodeWithImageNamed:@"Photo"];
    //photo.position = CGPointMake(thirdCol, firstRowHeight);
    photo.name = @"photo";
    [self addChild:photo];
    
    SKSpriteNode *bank = [SKSpriteNode spriteNodeWithImageNamed:@"Bank"];
    //bank.position = CGPointMake(firstCol, secondRowHeight);
    bank.name = @"bank";
    [self addChild:bank];
    
    SKSpriteNode *facebook = [SKSpriteNode spriteNodeWithImageNamed:@"Facebook"];
    //facebook.position = CGPointMake(secondCol, secondRowHeight);
    facebook.name = @"facebook";
    [self addChild:facebook];
    
    SKSpriteNode *task = [SKSpriteNode spriteNodeWithImageNamed:@"Task"];
    //task.position = CGPointMake(thirdCol, secondRowHeight);
    task.name = @"task";
    [self addChild:task];
    
    SKSpriteNode *tracking = [SKSpriteNode spriteNodeWithImageNamed:@"Tracking"];
    //tracking.position = CGPointMake(firstCol, thirdRowHeight);
    tracking.name = @"tracking";
    [self addChild:tracking];
    
    SKSpriteNode *settings = [SKSpriteNode spriteNodeWithImageNamed:@"Settings"];
    //settings.position = CGPointMake(secondCol, thirdRowHeight);
    settings.name = @"settings";
    [self addChild:settings];
    
    
    _homeArray = @[@[phone, iMessage, photo],
                           @[bank, facebook, task],
                           @[tracking,settings]];
    
    for(int i = 0; i < [_homeArray count]; i++){
        NSArray* row = [_homeArray objectAtIndex:i];
        for(int j = 0; j < [row count]; j++){
            SKSpriteNode* spriteObj = [row objectAtIndex:j];
            CGFloat xPos;
            CGFloat yPos;
            switch(i){
                case 0:{
                    xPos = firstCol;
                } break;
                case 1:{
                    xPos = secondCol;
                } break;
                case 2:{
                    xPos = thirdCol;
                }break;
            }
            switch(j){
                case 0:{
                    yPos = firstRowHeight;
                } break;
                case 1:{
                    yPos = secondRowHeight;
                } break;
                case 2:{
                    yPos = thirdRowHeight;
                }break;
            }
            spriteObj.position = CGPointMake(xPos, yPos);
            [self performSelectorInBackground:@selector(animateAppIcon:) withObject:spriteObj];
            
        }
    }
    [self showSiri:@"My name is siri. I am your personal assistant. By the way, you look like shit today. Just kidding!" withSound:@"personal.m4a" noBtn:nil yesBtn:nil onComplete:@selector(showJenPhoneCall)];
}

-(void)animateAppIcon:(SKSpriteNode*)spriteObj{
    [spriteObj setScale:3.0];
    spriteObj.alpha = 0;
    
    SKAction* alpha;
    if(spriteObj.position.x != CGRectGetMidX(self.frame)){
        alpha = [SKAction fadeInWithDuration:0.5f];
    } else {
        alpha = [SKAction fadeInWithDuration:0.1f];
    }
    SKAction* scale = [SKAction scaleTo:1.0 duration:0.4f];
    //SKAction* sequence = [SKAction sequence:@[alpha,scale]];
    scale.timingMode = SKActionTimingLinear;
    [spriteObj runAction:alpha];
    [spriteObj runAction:scale];
}

-(void)hideAppIcon:(SEL)onComplete{
    for(int i = 0; i < [_homeArray count]; i++){
        NSArray* row = [_homeArray objectAtIndex:i];
        for(int j = 0; j < [row count]; j++){
            SKSpriteNode* spriteObj = [row objectAtIndex:j];
            SKAction* alpha;
            SKAction* scale;
            if(spriteObj.position.x != CGRectGetMidX(self.frame)){
                alpha = [SKAction fadeOutWithDuration:0.2f];
                scale = [SKAction scaleTo:0.0 duration:0.2f];
            } else {
                alpha = [SKAction fadeOutWithDuration:0.1f];
                scale = [SKAction scaleTo:0.0 duration:0.1f];
            }
            //SKAction* scale = [SKAction scaleTo:1.0 duration:0.4f];
            //SKAction* sequence = [SKAction sequence:@[scale,alpha]];
            scale.timingMode = SKActionTimingLinear;
            //[spriteObj runAction:sequence];
            [spriteObj runAction:alpha];
            [spriteObj runAction:scale completion:^{
                if(i == [_homeArray count] - 1 && j == [row count] - 1){
                [self performSelector:onComplete];
                }
            }];
        }
    }
}

-(void)showAppIcon{
    for(int i = 0; i < [_homeArray count]; i++){
        NSArray* row = [_homeArray objectAtIndex:i];
        for(int j = 0; j < [row count]; j++){
            SKSpriteNode* spriteObj = [row objectAtIndex:j];
            [self animateAppIcon:spriteObj];
        }
    }

}

-(void)showSiri:(NSString*)text withSound:(NSString*)soundPath noBtn:(SEL)noBtnAction yesBtn:(SEL)yesBtnAction onComplete:(SEL)complete{
    //_siriLayer = [[UIView alloc] init];
    //_siriLayer.backgroundColor = [UIColor blackColor];
    _siriLayer = [[UIToolbar alloc] init];
    [_siriLayer setBarStyle:UIBarStyleBlack];
    
    UIImageView* siri = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"osxcircle"]];
    [siri setFrame:CGRectMake(0,0,122/2,122/2)];
    siri.center = CGPointMake(self.view.center.x, 80);
    
    UIImageView* siriSmile = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"smile"]];
    [siriSmile setFrame:CGRectMake(0,0,44/2,45/2)];
    siriSmile.center = CGPointMake(self.view.center.x, 80);
    
    [_siriLayer addSubview:siriSmile];
    [_siriLayer addSubview:siri];
    
    CABasicAnimation *rotation;
    rotation = [CABasicAnimation animationWithKeyPath:@"transform.rotation"];
    rotation.fromValue = [NSNumber numberWithFloat:0];
    rotation.toValue = [NSNumber numberWithFloat:(2*M_PI)];
    rotation.duration = 1.1; // Speed
    rotation.repeatCount = HUGE_VALF; // Repeat forever. Can be a finite number.
    [siri.layer addAnimation:rotation forKey:@"Spin"];
    
    UILabel* subtitle = [[UILabel alloc] initWithFrame:CGRectMake(30, 0, 320-30, 0)];
    subtitle.textColor = [UIColor whiteColor];
    subtitle.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:24.0f];
    subtitle.numberOfLines = 0;
    subtitle.textAlignment = NSTextAlignmentCenter;
    [subtitle setText:text];
    [subtitle sizeToFit];
    subtitle.center = CGPointMake(self.view.center.x, 0);
    subtitle.frame = CGRectMake(subtitle.frame.origin.x, 140, subtitle.frame.size.width, subtitle.frame.size.height);
    [_siriLayer addSubview:subtitle];
    
    CGFloat currentHeight = subtitle.frame.origin.y + subtitle.frame.size.height;
    
    if(noBtnAction != nil && yesBtnAction!= nil){
        UIButton* noBtn = [[UIButton alloc] initWithFrame:CGRectMake(30,currentHeight + 30,120,50)];
        [noBtn addTarget:self action:noBtnAction forControlEvents:UIControlEventTouchUpInside];
        noBtn.layer.cornerRadius = 25; // this value vary as per your desire
        noBtn.clipsToBounds = YES;
        [noBtn setBackgroundColor:[UIColor grayColor]];
        [noBtn setTitle:@"No" forState:UIControlStateNormal];
        [_siriLayer addSubview:noBtn];

    
        UIButton* yesBtn = [[UIButton alloc] initWithFrame:CGRectMake(noBtn.frame.origin.x + noBtn.frame.size.width + 20,currentHeight + 30,120,50)];
        [yesBtn addTarget:self action:yesBtnAction forControlEvents:UIControlEventTouchUpInside];
        yesBtn.layer.cornerRadius = 25; // this value vary as per your desire
        yesBtn.clipsToBounds = YES;
        [yesBtn setBackgroundColor:[UIColor greenColor]];
        [yesBtn setTitle:@"Yes" forState:UIControlStateNormal];
        [_siriLayer addSubview:yesBtn];
    
        currentHeight = yesBtn.frame.origin.y + yesBtn.frame.size.height;
    } else {
        currentHeight = currentHeight;
    }
    
    UIImageView* footer = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"siri_button"]];
    footer.center = CGPointMake(self.view.center.x, 0);
    footer.frame = CGRectMake(footer.frame.origin.x + 71/4, currentHeight + 20, 71/2, 16/2);
    [_siriLayer addSubview:footer];
    currentHeight = currentHeight + 36/2 + 20;
    
    _siriLayer.frame = CGRectMake(0, -currentHeight, 320, currentHeight);
    [self.scene.view addSubview:_siriLayer];

    
    [UIView animateWithDuration:0.4
                          delay:2.0
                        options: UIViewAnimationCurveEaseOut
                     animations:^{
                         //osxSprite.alpha = 1;
                         _siriLayer.frame = CGRectMake(0,0,320,currentHeight);
                     }
                     completion:^(BOOL finished){
                         [self runAction:[SKAction playSoundFileNamed:soundPath waitForCompletion:YES] completion:^{
                             if(noBtnAction == nil || yesBtnAction == nil){
                                 [self hideSiri];
                                 if(complete){
                                     [self performSelector:complete withObject:nil afterDelay:3.0f];
                                 }
                             }
                          }];
                         
                         //NSLog(@"Done!");
                     }];
}

-(void)hideSiri{
    [UIView animateWithDuration:0.4
                          delay:0.0
                        options: UIViewAnimationCurveEaseOut
                     animations:^{
                         //osxSprite.alpha = 1;
                         _siriLayer.frame = CGRectMake(0,-300,320,300);
                     }
                     completion:^(BOOL finished){
                         [[_siriLayer subviews] makeObjectsPerformSelector:@selector(removeFromSuperview)];
                         [_siriLayer removeFromSuperview];
                         //NSLog(@"Done!");
                     }];

}

-(void)noBtnClick{
    [self hideSiri];
}

-(void)yesBtnClick{
    [self hideSiri];
}

-(void)showJenPhoneCall{
    SKAction* sequence = [SKAction playSoundFileNamed:@"ringtone.m4a" waitForCompletion:YES];
    [self runAction:[SKAction repeatActionForever:sequence]];

    _jen_phonecall = [SKSpriteNode spriteNodeWithImageNamed:@"jen_calling"];
    _jen_phonecall.zPosition = 1;
    _jen_phonecall.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    _jen_phonecall.name = @"jen_calling";
    [self addChild:_jen_phonecall];
    
    _jen_btn_takecall = [SKSpriteNode spriteNodeWithImageNamed:@"bn_takecall"];
    _jen_btn_takecall.zPosition = 1;
    _jen_btn_takecall.position = CGPointMake(CGRectGetMidX(self.frame) + 150, 230);
    _jen_btn_takecall.name = @"jen_btn_takecall";
    [self addChild:_jen_btn_takecall];
    
    _jen_btn_endcall = [SKSpriteNode spriteNodeWithImageNamed:@"bn_endcall"];
    _jen_btn_endcall.zPosition = 1;
    _jen_btn_endcall.position = CGPointMake(CGRectGetMidX(self.frame) - 150, 230);
    _jen_btn_endcall.name = @"jen_btn_endcall";
    [self addChild:_jen_btn_endcall];
    
    //[jen_calling removeFromParent];
}

-(void)showJenPhoneCall2{
    SKAction* sequence = [SKAction playSoundFileNamed:@"ringtone.m4a" waitForCompletion:YES];
    [self runAction:[SKAction repeatActionForever:sequence]];
    
    _jen_phonecall = [SKSpriteNode spriteNodeWithImageNamed:@"jen_calling"];
    _jen_phonecall.zPosition = 1;
    _jen_phonecall.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    _jen_phonecall.name = @"jen_calling";
    [self addChild:_jen_phonecall];
    
    _jen_btn_takecall = [SKSpriteNode spriteNodeWithImageNamed:@"bn_takecall"];
    _jen_btn_takecall.zPosition = 1;
    _jen_btn_takecall.position = CGPointMake(CGRectGetMidX(self.frame) + 150, 230);
    _jen_btn_takecall.name = @"jen_btn_takecall2";
    [self addChild:_jen_btn_takecall];
    
    _jen_btn_endcall = [SKSpriteNode spriteNodeWithImageNamed:@"bn_endcall"];
    _jen_btn_endcall.zPosition = 1;
    _jen_btn_endcall.position = CGPointMake(CGRectGetMidX(self.frame) - 150, 230);
    _jen_btn_endcall.name = @"jen_btn_endcall2";
    [self addChild:_jen_btn_endcall];
    
    //[jen_calling removeFromParent];
}

-(void)jenAcceptCall{
    _jen_incall = [SKSpriteNode spriteNodeWithImageNamed:@"jen_answering"];
    _jen_incall.zPosition = 1;
    _jen_incall.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    _jen_incall.name = @"jen_incall";
    [self addChild:_jen_incall];
    [self performSelector:@selector(blackmailCall) withObject:nil afterDelay:2.0f];
}

-(void)jenAcceptCall2{
    _jen_incall = [SKSpriteNode spriteNodeWithImageNamed:@"jen_answering"];
    _jen_incall.zPosition = 1;
    _jen_incall.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    _jen_incall.name = @"jen_incall";
    [self addChild:_jen_incall];
    [self performSelector:@selector(blackmailCall2) withObject:nil afterDelay:2.0f];
}

-(void)blackmailCall{
    [self runAction:[SKAction playSoundFileNamed:@"blackmail.m4a" waitForCompletion:YES] completion:^{
        [_jen_incall removeFromParent];
        [self showSiri:@"It seems that your girlfriend got kidnapped by someone. Do you want me to save her ass by calling the cops?" withSound:@"Kidnap.m4a" noBtn:@selector(ignoreCopsCall) yesBtn:@selector(callCops) onComplete:nil];
    }];
}

-(void)blackmailCall2{
    [self runAction:[SKAction playSoundFileNamed:@"blackmail2.m4a" waitForCompletion:YES] completion:^{
        [_jen_incall removeFromParent];
        [self showGameOver];
    }];
}

-(void)showGameOver{
    _gameOver = [SKSpriteNode spriteNodeWithImageNamed:@"gameover"];
    _gameOver.zPosition = 1;
    _gameOver.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    _gameOver.name = @"gameover";
    [self addChild:_gameOver];
}

-(void)showTaskApp{
    _task = [SKSpriteNode spriteNodeWithImageNamed:@"taskpage"];
    _task.zPosition = 1;
    _task.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    _task.name = @"taskpage";
    [self addChild:_task];
    
    [_task setScale:0.3];
    SKAction* scale = [SKAction scaleTo:1.0 duration:0.2f];
    [_task runAction:scale completion:^{
        [self showSiri:@"Today, you have four tasks to make some cash" withSound:@"task.m4a" noBtn:nil yesBtn:nil onComplete:nil];
    }];
    
}

-(void)showFbApp{
    
}

-(void)showLiked:(SEL)complete{
    [self runAction:[SKAction playSoundFileNamed:@"cashreward.m4a" waitForCompletion:NO]];
    
    SKSpriteNode* like = [SKSpriteNode spriteNodeWithImageNamed:@"liked"];
    like.zPosition = 3;
    like.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    like.name = @"like";
    [self addChild:like];
    [like setScale:4];
    [like setAlpha:0];
    
    SKAction* show = [SKAction scaleTo:1.0 duration:0.25];
    SKAction* alpha = [SKAction fadeInWithDuration:0.3];
    SKAction* stay = [SKAction waitForDuration:0.5f];
    SKAction* fadeout = [SKAction fadeOutWithDuration:0.3];
    SKAction* remove = [SKAction removeFromParent];
    show.timingMode = SKActionTimingEaseOut;
    
    SKAction* se = [SKAction sequence:@[alpha,stay,fadeout,remove]];
    [like runAction:show];
    [like runAction:se completion:^{
        if(complete)
        [self performSelector:complete];
        //[self performSelector:complete withObject:nil afterDelay:1.0f];
        //[self performSelector:complete afterDelay:1.0f];
    }];
}

-(void)showFb1{
    _fbPhoto1 = [SKSpriteNode spriteNodeWithImageNamed:@"p1"];
    _fbPhoto1.zPosition = 1;
    _fbPhoto1.position = CGPointMake(CGRectGetMaxX(self.frame), CGRectGetMidY(self.frame));
    _fbPhoto1.name = @"fbPhoto1";
    [self addChild:_fbPhoto1];
    
    SKAction* show = [SKAction moveToX:CGRectGetMidX(self.frame) duration:0.3];
    show.timingMode = SKActionTimingEaseOut;
    [_fbPhoto1 runAction:show];
}

-(void)showFb2{
    _fbPhoto2 = [SKSpriteNode spriteNodeWithImageNamed:@"p2"];
    _fbPhoto2.zPosition = 1;
    _fbPhoto2.position = CGPointMake(CGRectGetMaxX(self.frame), CGRectGetMidY(self.frame));
    _fbPhoto2.name = @"fbPhoto2";
    [self addChild:_fbPhoto2];
    
    SKAction* show = [SKAction moveToX:CGRectGetMidX(self.frame) duration:0.3];
    show.timingMode = SKActionTimingEaseOut;
    [_fbPhoto2 runAction:show];
}

-(void)showFb3{
    _fbPhoto3 = [SKSpriteNode spriteNodeWithImageNamed:@"p3"];
    _fbPhoto3.zPosition = 1;
    _fbPhoto3.position = CGPointMake(CGRectGetMaxX(self.frame), CGRectGetMidY(self.frame));
    _fbPhoto3.name = @"fbPhoto3";
    [self addChild:_fbPhoto3];
    
    SKAction* show = [SKAction moveToX:CGRectGetMidX(self.frame) duration:0.3];
    show.timingMode = SKActionTimingEaseOut;
    [_fbPhoto3 runAction:show];
}

-(void)showFb4{
    _fbPhoto4 = [SKSpriteNode spriteNodeWithImageNamed:@"p4"];
    _fbPhoto4.zPosition = 1;
    _fbPhoto4.position = CGPointMake(CGRectGetMaxX(self.frame), CGRectGetMidY(self.frame));
    _fbPhoto4.name = @"fbPhoto4";
    [self addChild:_fbPhoto4];
    
    SKAction* show = [SKAction moveToX:CGRectGetMidX(self.frame) duration:0.3];
    show.timingMode = SKActionTimingEaseOut;
    [_fbPhoto4 runAction:show];
}

-(void)showFb5{
    _fbPhoto5 = [SKSpriteNode spriteNodeWithImageNamed:@"p5"];
    _fbPhoto5.zPosition = 1;
    _fbPhoto5.position = CGPointMake(CGRectGetMaxX(self.frame), CGRectGetMidY(self.frame));
    _fbPhoto5.name = @"fbPhoto5";
    [self addChild:_fbPhoto5];
    
    SKAction* show = [SKAction moveToX:CGRectGetMidX(self.frame) duration:0.3];
    show.timingMode = SKActionTimingEaseOut;
    [_fbPhoto5 runAction:show];
}

-(void)showFb6{
    _fbPhoto6 = [SKSpriteNode spriteNodeWithImageNamed:@"p6"];
    _fbPhoto6.zPosition = 1;
    _fbPhoto6.position = CGPointMake(CGRectGetMaxX(self.frame), CGRectGetMidY(self.frame));
    _fbPhoto6.name = @"fbPhoto6";
    [self addChild:_fbPhoto6];
    
    SKAction* show = [SKAction moveToX:CGRectGetMidX(self.frame) duration:0.3];
    show.timingMode = SKActionTimingEaseOut;
    [_fbPhoto6 runAction:show];
}

-(void)showTrackingApp{
    _tracking = [SKSpriteNode spriteNodeWithImageNamed:@"Stalking"];
    _tracking.zPosition = 1;
    _tracking.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    _tracking.name = @"Stalking";
    [self addChild:_tracking];
    
    [_tracking setScale:0.3];
    SKAction* scale = [SKAction scaleTo:1.0 duration:0.2f];
    [_tracking runAction:scale];
}

-(void)showStalkingApp{
    _stalking = [SKSpriteNode spriteNodeWithImageNamed:@"Stalking2"];
    _stalking.zPosition = 1;
    _stalking.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    _stalking.name = @"Stalking2";
    [self addChild:_stalking];
    
    _stalking_logo = [SKSpriteNode spriteNodeWithImageNamed:@"Stalking2_logo"];
    _stalking_logo.zPosition = 1;
    _stalking_logo.position = CGPointMake(CGRectGetMidX(self.frame), 356);
    _stalking_logo.name = @"stalking_logo";
    [self addChild:_stalking_logo];
    
    SKAction* sequence = [SKAction rotateByAngle:[self degToRad:360.0f] duration:1.5];
    [_stalking_logo runAction:[SKAction sequence:@[sequence,sequence,sequence]] completion:^{
        _map = [SKSpriteNode spriteNodeWithImageNamed:@"map"];
        _map.zPosition = 1;
        _map.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
        _map.name = @"map";
        [self addChild:_map];
        [self showSiri:@"Matthew, I got an idea. Why don't you ask me to blow up that phone? I'm sure michael bay would agree." withSound:@"blowup.m4a" noBtn:@selector(notBlow) yesBtn:@selector(blow) onComplete:nil];
    }];
    //[_stalking_logo runAction:[SKAction repeatActionForever:sequence]];
    //[_tracking setScale:0.3];
    //SKAction* scale = [SKAction scaleTo:1.0 duration:0.2f];
    //[_tracking runAction:scale];
}
     
-(void)blow{
    [self hideSiri];
    [self showGameOver];
}
     
-(void)notBlow{
         
}

-(void)callCops{
    [self hideSiri];
    [self performSelector:@selector(showJenPhoneCall2) withObject:nil afterDelay:3.0f];
}

-(void)ignoreCopsCall{
    [self hideSiri];
}

-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    UITouch *touch = [touches anyObject];
    CGPoint location = [touch locationInNode:self];
    SKNode *node = [self nodeAtPoint:location];

    NSLog(@"%@", [node name]);
    if([[node name] isEqualToString:@"jen_btn_endcall"]){
        [self removeAllActions];
        [_jen_btn_endcall removeFromParent];
        [_jen_btn_takecall removeFromParent];
        [_jen_phonecall removeFromParent];
    } else if([[node name] isEqualToString:@"jen_btn_takecall"]){
        [self removeAllActions];
        [_jen_btn_endcall removeFromParent];
        [_jen_btn_takecall removeFromParent];
        [_jen_phonecall removeFromParent];
        [self jenAcceptCall];
    } else if([[node name] isEqualToString:@"jen_btn_takecall2"]){
        [self removeAllActions];
        [_jen_btn_endcall removeFromParent];
        [_jen_btn_takecall removeFromParent];
        [_jen_phonecall removeFromParent];
        [self jenAcceptCall2];
    } else if([[node name] isEqualToString:@"jen_btn_endcall2"]){
        [self removeAllActions];
        [_jen_btn_endcall removeFromParent];
        [_jen_btn_takecall removeFromParent];
        [_jen_phonecall removeFromParent];
        [self jenAcceptCall2];
    } else if([[node name] isEqualToString:@"gameover"]){
        //[_gameOver removeFromParent];
        GameScene *homeScene = [[GameScene alloc] initWithSize:self.size];
        //homeScene.scaleMode = SKSceneScaleModeAspectFill;
        SKTransition *transition = [SKTransition crossFadeWithDuration:0.7];
        [self.view presentScene:homeScene transition:transition];
    } else if([[node name] isEqualToString:@"tracking"]){
        [self hideAppIcon:@selector(showTrackingApp)];
    } else if([[node name] isEqualToString:@"Stalking"]){
        [self showStalkingApp];
    } else if([[node name] isEqualToString:@"task"]){
        [self hideAppIcon:@selector(showTaskApp)];
        //[self showFb1];
    } else if([[node name] isEqualToString:@"taskpage"]){
        [self showFb1];
    } else if([[node name] isEqualToString:@"fbPhoto1"]){
        [self showLiked:@selector(showFb2)];
    } else if([[node name] isEqualToString:@"fbPhoto2"]){
        [self showLiked:@selector(showFb3)];
    } else if([[node name] isEqualToString:@"fbPhoto3"]){
        [self showLiked:@selector(showFb4)];
    } else if([[node name] isEqualToString:@"fbPhoto4"]){
        [self showLiked:@selector(showFb5)];
    } else if([[node name] isEqualToString:@"fbPhoto5"]){
        [self showLiked:@selector(showFb6)];
    } else if([[node name] isEqualToString:@"fbPhoto6"]){
        [self showLiked:nil];
        [self showMasterStalker];
    } else if([[node name] isEqualToString:@"bank"]){
        [self hideAppIcon:@selector(showBankPage)];
    } else if([[node name] isEqualToString:@"bankPage"]){
        [self showBank2];
    }

}

-(void)showMasterStalker{
    [self showSiri:@"Congratulations! You are now a master stalker. Huehuehue" withSound:@"Stalker.m4a" noBtn:nil yesBtn:nil onComplete:@selector(backToHome)];
}

-(void)showBankPage{
    _bankPage = [SKSpriteNode spriteNodeWithImageNamed:@"bankpage"];
    _bankPage.zPosition = 1;
    _bankPage.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    _bankPage.name = @"bankPage";
    [self addChild:_bankPage];
    
    [_bankPage setScale:0.3];
    SKAction* scale = [SKAction scaleTo:1.0 duration:0.2f];
    [_bankPage runAction:scale completion:^{
        //[self showSiri:@"Today, you have four tasks to make some cash" withSound:@"task.m4a" noBtn:nil yesBtn:nil onComplete:nil];
    }];
}

-(void)showBank2{
    _bank2 = [SKSpriteNode spriteNodeWithImageNamed:@"bank2"];
    _bank2.zPosition = 1;
    _bank2.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
    _bank2.name = @"bank2";
    [self addChild:_bank2];
    
    SKSpriteNode* turn = [SKSpriteNode spriteNodeWithImageNamed:@"turn"];
    turn.zPosition = 1;
    turn.position = CGPointMake(CGRectGetMidX(self.frame), 1136 - 250);
    turn.name = @"turn";
    [self addChild:turn];
    
    SKAction* enlarge = [SKAction scaleTo:1.1 duration:1.0];
    SKAction* normalSize = [SKAction scaleTo:1.0 duration:1.0];

    
    enlarge.timingMode = SKActionTimingEaseOut;
    normalSize.timingMode = SKActionTimingEaseIn;
    
    SKAction* se = [SKAction sequence:@[enlarge,normalSize]];
    [turn runAction:[SKAction repeatActionForever:se]];
    
    SKAction *sequence = [SKAction sequence:@[[SKAction rotateByAngle:[self degToRad:-20.0f] duration:1.0],
                                              [SKAction rotateByAngle:[self degToRad:20.0f] duration:1.0]]];
    [turn runAction:[SKAction repeatActionForever:sequence]];
    
    
    [self showSiri:@"Matthew, you have successfully transferred all you money to the blackmailer. Good luck with that." withSound:@"money.m4a" noBtn:nil yesBtn:nil onComplete:@selector(showGameOver)];
//    [self runAction:[SKAction playSoundFileNamed:@"money.m4a" waitForCompletion:YES] completion:^{
//        
//    }];
}

-(void)backToHome{
    [_task removeFromParent];
    [_fbPhoto1 removeFromParent];
    [_fbPhoto2 removeFromParent];
    [_fbPhoto3 removeFromParent];
    [_fbPhoto4 removeFromParent];
    [_fbPhoto5 removeFromParent];
    [_fbPhoto6 removeFromParent];
    [self showAppIcon];
}

-(float) degToRad:(float) degree {
    return degree / 180.0f * M_PI;
}

@end
